# Update strategy segments POST https://app.unleash-instance.example.com/api/admin/segments/strategies Content-Type: application/json Sets the segments of the strategy specified to be exactly the ones passed in the payload. Any segments that were used by the strategy before will be removed if they are not in the provided list of segments. Reference: https://docs.getunleash.io/api/update-feature-strategy-segments ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Update strategy segments version: endpoint_strategies.updateFeatureStrategySegments paths: /api/admin/segments/strategies: post: operationId: update-feature-strategy-segments summary: Update strategy segments description: >- Sets the segments of the strategy specified to be exactly the ones passed in the payload. Any segments that were used by the strategy before will be removed if they are not in the provided list of segments. tags: - - subpackage_strategies parameters: - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '201': description: The resource was successfully created. content: application/json: schema: $ref: '#/components/schemas/updateFeatureStrategySegmentsSchema' '400': description: The request data does not match what we expect. content: {} '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '403': description: >- The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation content: {} '415': description: >- The operation does not support request payloads of the provided type. Please ensure that you're using one of the listed payload types and that you have specified the right content type in the "content-type" header. content: {} requestBody: description: updateFeatureStrategySegmentsSchema content: application/json: schema: $ref: '#/components/schemas/updateFeatureStrategySegmentsSchema' components: schemas: updateFeatureStrategySegmentsSchema: type: object properties: projectId: type: string description: The ID of the project that the strategy belongs to. strategyId: type: string description: The ID of the strategy to update segments for. environmentId: type: string description: The ID of the strategy environment. segmentIds: type: array items: type: integer description: >- The new list of segments (IDs) to use for this strategy. Any segments not in this list will be removed from the strategy. required: - projectId - strategyId - environmentId - segmentIds ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/segments/strategies" payload = { "projectId": "red-vista", "strategyId": "15d1e20b-6310-4e17-a0c2-9fb84de3053a", "environmentId": "development", "segmentIds": [1, 5, 6] } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/segments/strategies'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"projectId":"red-vista","strategyId":"15d1e20b-6310-4e17-a0c2-9fb84de3053a","environmentId":"development","segmentIds":[1,5,6]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/segments/strategies" payload := strings.NewReader("{\n \"projectId\": \"red-vista\",\n \"strategyId\": \"15d1e20b-6310-4e17-a0c2-9fb84de3053a\",\n \"environmentId\": \"development\",\n \"segmentIds\": [\n 1,\n 5,\n 6\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/segments/strategies") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"projectId\": \"red-vista\",\n \"strategyId\": \"15d1e20b-6310-4e17-a0c2-9fb84de3053a\",\n \"environmentId\": \"development\",\n \"segmentIds\": [\n 1,\n 5,\n 6\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/segments/strategies") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"projectId\": \"red-vista\",\n \"strategyId\": \"15d1e20b-6310-4e17-a0c2-9fb84de3053a\",\n \"environmentId\": \"development\",\n \"segmentIds\": [\n 1,\n 5,\n 6\n ]\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/segments/strategies', [ 'body' => '{ "projectId": "red-vista", "strategyId": "15d1e20b-6310-4e17-a0c2-9fb84de3053a", "environmentId": "development", "segmentIds": [ 1, 5, 6 ] }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/segments/strategies"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"projectId\": \"red-vista\",\n \"strategyId\": \"15d1e20b-6310-4e17-a0c2-9fb84de3053a\",\n \"environmentId\": \"development\",\n \"segmentIds\": [\n 1,\n 5,\n 6\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "projectId": "red-vista", "strategyId": "15d1e20b-6310-4e17-a0c2-9fb84de3053a", "environmentId": "development", "segmentIds": [1, 5, 6] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/segments/strategies")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```